## opennebula-7.1.80-1-arm64.tar.gz

=== src/client/SConstruct ===
# SConstruct for src/pool

# -------------------------------------------------------------------------- #
# Copyright 2002-2025, OpenNebula Project, OpenNebula Systems                #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

Import('env')

lib_name='nebula_client'

source_files=['Client.cc',
              'ClientXRPC.cc']

# Include dirs
if env['grpc'] == 'yes':
    source_files.append('ClientGRPC.cc')

# Build library
env.StaticLibrary(lib_name, source_files)

=== share/one/one-deploy/Makefile ===
SHELL := $(shell which bash)
SELF  := $(patsubst %/,%,$(dir $(abspath $(firstword $(MAKEFILE_LIST)))))

HATCH_BIN ?= $(shell command -v hatch)

ifneq ($(strip $(HATCH_BIN)),)
ENV_RUN      = $(HATCH_BIN) env run -e $(1) --
ENV_DEFAULT := $(shell $(HATCH_BIN) env find default)
ENV_CEPH    := $(shell $(HATCH_BIN) env find ceph)
endif

I         ?= $(SELF)/inventory/example.yml
INVENTORY ?= $(I)

T    ?=
TAGS ?= $(T)

S         ?=
SKIP_TAGS ?= $(S)

V       ?= vv
VERBOSE ?= $(V)

export

# Make sure we source ANSIBLE_ settings from ansible.cfg exclusively.
unexport $(filter ANSIBLE_%,$(.VARIABLES))

.PHONY: all

all: main

.PHONY: infra pre ceph site main

infra pre ceph site main: _TAGS      := $(if $(TAGS),-t $(TAGS),)
infra pre ceph site main: _SKIP_TAGS := $(if $(SKIP_TAGS),--skip-tags $(SKIP_TAGS),)
infra pre ceph site main: _VERBOSE   := $(if $(VERBOSE),-$(VERBOSE),)
infra pre ceph site main: _ASK_VAULT := $(if $(findstring $$ANSIBLE_VAULT;,$(file < $(INVENTORY))),--ask-vault-pass,)

ifdef ENV_DEFAULT
$(ENV_DEFAULT):
	$(HATCH_BIN) env create default
endif

infra pre site main: $(ENV_DEFAULT)
	cd $(SELF)/ && \
	$(call ENV_RUN,default) ansible-playbook $(_VERBOSE) -i $(INVENTORY) $(_ASK_VAULT) $(_TAGS) $(_SKIP_TAGS) opennebula.deploy.$@

ifdef ENV_CEPH
$(ENV_CEPH):
	$(HATCH_BIN) env create ceph
endif

ceph: $(ENV_CEPH)
	cd $(SELF)/ && \
	$(call ENV_RUN,ceph) ansible-playbook $(_VERBOSE) -i $(INVENTORY) $(_ASK_VAULT) $(_TAGS) $(_SKIP_TAGS) opennebula.deploy.$@

.PHONY: requirements requirements-hatch requirements-python requirements-galaxy clean-requirements

requirements: requirements-$(if $(ENV_RUN),hatch,python) requirements-galaxy

requirements-hatch: $(SELF)/pyproject.toml $(ENV_DEFAULT)

requirements-python: $(SELF)/requirements.txt
	pip3 install --requirement $<

requirements-galaxy: $(SELF)/requirements.yml $(ENV_DEFAULT)
	$(call ENV_RUN,default) ansible-galaxy collection install --requirements-file $< --collections-path $(SELF)/ansible_collections

clean-requirements:
	find $(SELF)/ansible_collections/ -mindepth 1 -maxdepth 1 -type d ! -name opennebula -exec rm -rf {} +
	$(if $(ENV_DEFAULT),$(HATCH_BIN) env remove default,)
	$(if $(ENV_CEPH),$(HATCH_BIN) env remove ceph,)

.PHONY: lint-ansible

lint-ansible: $(ENV_DEFAULT)
	cd $(SELF)/ && $(call ENV_RUN,default) ansible-lint roles/ playbooks/

=== src/oca/python/Makefile ===
# Copyright 2018 www.privaz.io Valletech AB
# Copyright 2002-2025, OpenNebula Project, OpenNebula Systems
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Use full path to ensure virtualenv compatibility
PYTHON = $(shell which python3)
GDS = $(shell which generateDS)
PWD = $(shell pwd)

PROTO_DIR = ../../../src/rm/grpc/proto
PROTOS = $(shell find $(PROTO_DIR) -name "*.proto")
GRPC_OUT = $(patsubst $(PROTO_DIR)/%.proto, pyone/grpc/%_pb2.py, $(PROTOS)) \
           $(patsubst $(PROTO_DIR)/%.proto, pyone/grpc/%_pb2_grpc.py, $(PROTOS))

schemas = index.xsd

VPATH = src: ../../../share/doc/xsd

ifneq ("${ROOT}","")
  root="--root=${ROOT}"
endif

all: pyone/bindings/__init__.py pyone/bindings/supbind.py grpc

pyone/bindings/__init__.py pyone/bindings/supbind.py: $(schemas)
	$(if $(GDS),,$(error generateDS not found. Please install it with: pip install generateDS))
	mkdir -p pyone/bindings
	${PYTHON} ${GDS} -q -f -o pyone/bindings/supbind.py -s pyone/bindings/__init__.py --super=supbind --external-encoding=utf-8 --silence $^
	sed -i "s/import supbind/from . import supbind/" pyone/bindings/__init__.py
	sed -i "s/import sys/import sys\nfrom pyone.util import TemplatedType/" pyone/bindings/__init__.py
	sed -i "s/(supermod\./(TemplatedType, supermod\./g" pyone/bindings/__init__.py

grpc: $(GRPC_OUT)

$(GRPC_OUT): $(PROTOS)
	mkdir -p pyone/grpc
	${PYTHON} -m grpc_tools.protoc -I$(PROTO_DIR) --python_out=pyone/grpc --grpc_python_out=pyone/grpc $(PROTOS)
	@echo "Fixing Python gRPC imports..."
	sed -i 's/^import .*_pb2/from . &/' pyone/grpc/*_pb2*.py

.PHONY: clean dist
clean:
	rm -rf build dist pyone/bindings pyone/grpc *.egg-info doc

dist:
	${PYTHON} setup.py sdist bdist_wheel

install:
	${PYTHON} setup.py install ${root}

doc:
	mkdir -p doc
	PYTHONPATH=$(PWD) pdoc --overwrite --html --html-no-source --html-dir doc pyone

=== share/one/one-deploy/ansible_collections/openstack/config_template/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest coverage gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/openstack-ansible-plugins.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/openstack-ansible-plugins.qhc"

applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/openstack-ansible-plugins"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/openstack-ansible-plugins"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

livehtml: html
	sphinx-autobuild -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

=== share/one/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/Makefile ===
hijack: all strip remove_unused_artifacts

hijack_remove_unused_artifacts: all remove_unused_artifacts


SHELL = /bin/sh

# V=0 quiet, V=1 verbose.  other values don't work.
V = 1
V0 = $(V:0=)
Q1 = $(V:1=)
Q = $(Q1:0=@)
ECHO1 = $(V:1=@ :)
ECHO = $(ECHO1:0=@ echo)
NULLCMD = :

#### Start of system configuration section. ####

srcdir = .
topdir = /usr/include
hdrdir = $(topdir)
arch_hdrdir = /usr/include
PATH_SEPARATOR = :
VPATH = $(srcdir):$(arch_hdrdir)/ruby:$(hdrdir)/ruby
prefix = $(DESTDIR)/usr
rubysitearchprefix = $(sitearchlibdir)/$(RUBY_BASE_NAME)
rubyarchprefix = $(DESTDIR)/usr/lib64/ruby
rubylibprefix = $(exec_prefix)/share/ruby
exec_prefix = $(DESTDIR)/usr
vendorarchhdrdir = $(vendorhdrdir)/$(arch)
sitearchhdrdir = $(sitehdrdir)/$(arch)
rubyarchhdrdir = $(DESTDIR)/usr/include
vendorhdrdir = $(rubyhdrdir)/vendor_ruby
sitehdrdir = $(rubyhdrdir)/site_ruby
rubyhdrdir = $(DESTDIR)/usr/include
rubygemsdir = $(DESTDIR)/usr/share/rubygems
vendorarchdir = $(DESTDIR)/usr/lib64/ruby/vendor_ruby
vendorlibdir = $(vendordir)
vendordir = $(DESTDIR)/usr/share/ruby/vendor_ruby
sitearchdir = $(DESTDIR)/usr/local/lib64/ruby/site_ruby
sitelibdir = $(sitedir)
sitedir = $(DESTDIR)/usr/local/share/ruby/site_ruby
rubyarchdir = $(rubyarchprefix)
rubylibdir = $(rubylibprefix)
sitearchincludedir = $(includedir)/$(sitearch)
archincludedir = $(includedir)/$(arch)
sitearchlibdir = $(libdir)/$(sitearch)
archlibdir = $(DESTDIR)/usr/lib64
ridir = $(datarootdir)/$(RI_BASE_NAME)
mandir = $(DESTDIR)/usr/share/man
localedir = $(datarootdir)/locale
libdir = $(exec_prefix)/lib64
psdir = $(docdir)
pdfdir = $(docdir)
dvidir = $(docdir)
htmldir = $(docdir)
infodir = $(DESTDIR)/usr/share/info
docdir = $(datarootdir)/doc/$(PACKAGE)
oldincludedir = $(DESTDIR)/usr/include
includedir = $(exec_prefix)/include
runstatedir = $(DESTDIR)/run
localstatedir = $(DESTDIR)/var
sharedstatedir = $(DESTDIR)/var/lib
sysconfdir = $(DESTDIR)/etc
datadir = $(DESTDIR)/usr/share
datarootdir = $(prefix)/share
libexecdir = $(DESTDIR)/usr/libexec
sbindir = $(DESTDIR)/usr/sbin
bindir = $(exec_prefix)/bin
archdir = $(rubyarchdir)


CC_WRAPPER = 
CC = gcc
CXX = g++
LIBRUBY = $(LIBRUBY_SO)
LIBRUBY_A = lib$(RUBY_SO_NAME)-static.a
LIBRUBYARG_SHARED = -l$(RUBY_SO_NAME)
LIBRUBYARG_STATIC = -l$(RUBY_SO_NAME)-static $(MAINLIBS)
empty =
OUTFLAG = -o $(empty)
COUTFLAG = -o $(empty)
CSRCFLAG = $(empty)

RUBY_EXTCONF_H = 
cflags   = $(hardenflags)  $(optflags) $(debugflags) $(warnflags)
cxxflags = 
optflags = -O3 -fno-fast-math
debugflags = -ggdb3
warnflags = -Wall -Wextra -Wdeprecated-declarations -Wdiv-by-zero -Wduplicated-cond -Wimplicit-function-declaration -Wimplicit-int -Wpointer-arith -Wwrite-strings -Wold-style-definition -Wimplicit-fallthrough=0 -Wmissing-noreturn -Wno-cast-function-type -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-packed-bitfield-compat -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wsuggest-attribute=format -Wsuggest-attribute=noreturn -Wunused-variable -Wmisleading-indentation -Wundef
cppflags = 
CCDLFLAGS = -fPIC
CFLAGS   = $(CCDLFLAGS) -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer  -fPIC -I/builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/include -g -std=c11  -Wall  -Wextra  -pedantic  $(ARCH_FLAG)
INCFLAGS = -I. -I$(arch_hdrdir) -I$(hdrdir)/ruby/backward -I$(hdrdir) -I$(srcdir)
DEFS     = 
CPPFLAGS =   $(DEFS) $(cppflags)
CXXFLAGS = $(CCDLFLAGS) -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -mbranch-protection=standard -fasynchronous-unwind-tables -fstack-clash-protection -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer  $(ARCH_FLAG)
ldflags  = -L. -Wl,-z,relro -Wl,--as-needed  -Wl,-z,pack-relative-relocs -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -specs=/usr/lib/rpm/redhat/redhat-hardened-ld-errors -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -Wl,--build-id=sha1   -fstack-protector-strong -rdynamic -Wl,-export-dynamic -Wl,--no-as-needed -Wl,--version-script="/builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/ext-export.gcc" /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/libgrpc.a -static-libgcc -static-libstdc++
dldflags = -Wl,-z,relro -Wl,--as-needed  -Wl,-z,pack-relative-relocs -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -specs=/usr/lib/rpm/redhat/redhat-hardened-ld-errors -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -Wl,--build-id=sha1   
ARCH_FLAG = 
DLDFLAGS = $(ldflags) $(dldflags) $(ARCH_FLAG)
LDSHARED = $(CC) -shared
LDSHAREDXX = $(CXX) -shared
AR = gcc-ar
EXEEXT = 

RUBY_INSTALL_NAME = $(RUBY_BASE_NAME)
RUBY_SO_NAME = ruby
RUBYW_INSTALL_NAME = 
RUBY_VERSION_NAME = $(RUBY_BASE_NAME)-$(ruby_version_dir_name)
RUBYW_BASE_NAME = rubyw
RUBY_BASE_NAME = ruby

arch = aarch64-linux
sitearch = $(arch)
ruby_version = 3.3.0
ruby = $(bindir)/$(RUBY_BASE_NAME)
RUBY = $(ruby)
BUILTRUBY = $(bindir)/$(RUBY_BASE_NAME)
ruby_headers = $(hdrdir)/ruby.h $(hdrdir)/ruby/backward.h $(hdrdir)/ruby/ruby.h $(hdrdir)/ruby/defines.h $(hdrdir)/ruby/missing.h $(hdrdir)/ruby/intern.h $(hdrdir)/ruby/st.h $(hdrdir)/ruby/subst.h $(arch_hdrdir)/ruby/config.h

RM = rm -f
RM_RF = rm -fr
RMDIRS = rmdir --ignore-fail-on-non-empty -p
MAKEDIRS = /usr/bin/mkdir -p
INSTALL = /usr/bin/install -c
INSTALL_PROG = $(INSTALL) -m 0755
INSTALL_DATA = $(INSTALL) -m 644
COPY = cp
TOUCH = exit >

#### End of system configuration section. ####

preload = 
libpath = . $(archlibdir)
LIBPATH =  -L. -L$(archlibdir)
DEFFILE = 

CLEANFILES = mkmf.log
DISTCLEANFILES = 
DISTCLEANDIRS = 

extout = 
extout_prefix = 
target_prefix = /grpc
LOCAL_LIBS = 
LIBS = $(LIBRUBYARG_SHARED)  -lm -lpthread  -lc
ORIG_SRCS = rb_byte_buffer.c rb_call.c rb_call_credentials.c rb_channel.c rb_channel_args.c rb_channel_credentials.c rb_completion_queue.c rb_compression_options.c rb_event_thread.c rb_grpc.c rb_grpc_imports.generated.c rb_loader.c rb_server.c rb_server_credentials.c rb_xds_channel_credentials.c rb_xds_server_credentials.c rb_enable_cpp.cc
SRCS = $(ORIG_SRCS) 
OBJS = rb_byte_buffer.o rb_call.o rb_call_credentials.o rb_channel.o rb_channel_args.o rb_channel_credentials.o rb_completion_queue.o rb_compression_options.o rb_event_thread.o rb_grpc.o rb_grpc_imports.generated.o rb_loader.o rb_server.o rb_server_credentials.o rb_xds_channel_credentials.o rb_xds_server_credentials.o rb_enable_cpp.o
HDRS = $(srcdir)/rb_byte_buffer.h $(srcdir)/rb_call.h $(srcdir)/rb_call_credentials.h $(srcdir)/rb_channel.h $(srcdir)/rb_channel_args.h $(srcdir)/rb_channel_credentials.h $(srcdir)/rb_completion_queue.h $(srcdir)/rb_compression_options.h $(srcdir)/rb_event_thread.h $(srcdir)/rb_grpc.h $(srcdir)/rb_grpc_imports.generated.h $(srcdir)/rb_loader.h $(srcdir)/rb_server.h $(srcdir)/rb_server_credentials.h $(srcdir)/rb_xds_channel_credentials.h $(srcdir)/rb_xds_server_credentials.h
LOCAL_HDRS = 
TARGET = grpc_c
TARGET_NAME = grpc_c
TARGET_ENTRY = Init_$(TARGET_NAME)
DLLIB = $(TARGET).so
EXTSTATIC = 
STATIC_LIB = 

TIMESTAMP_DIR = .
BINDIR        = $(bindir)
RUBYCOMMONDIR = $(sitedir)$(target_prefix)
RUBYLIBDIR    = $(sitelibdir)$(target_prefix)
RUBYARCHDIR   = $(sitearchdir)$(target_prefix)
HDRDIR        = $(sitehdrdir)$(target_prefix)
ARCHHDRDIR    = $(sitearchhdrdir)$(target_prefix)
TARGET_SO_DIR =
TARGET_SO     = $(TARGET_SO_DIR)$(DLLIB)
CLEANLIBS     = $(TARGET_SO) false
CLEANOBJS     = $(OBJS) *.bak
TARGET_SO_DIR_TIMESTAMP = $(TIMESTAMP_DIR)/.sitearchdir.-.grpc.time

all:    $(DLLIB)
static: $(STATIC_LIB)
.PHONY: all install static install-so install-rb
.PHONY: clean clean-so clean-static clean-rb

clean-static::
clean-rb-default::
clean-rb::
clean-so::
clean: clean-so clean-static clean-rb-default clean-rb
		-$(Q)$(RM_RF) $(CLEANLIBS) $(CLEANOBJS) $(CLEANFILES) .*.time

distclean-rb-default::
distclean-rb::
distclean-so::
distclean-static::
distclean: clean distclean-so distclean-static distclean-rb-default distclean-rb
		-$(Q)$(RM) Makefile $(RUBY_EXTCONF_H) conftest.* mkmf.log
		-$(Q)$(RM) core ruby$(EXEEXT) *~ $(DISTCLEANFILES)
		-$(Q)$(RMDIRS) $(DISTCLEANDIRS) 2> /dev/null || true

realclean: distclean
install: install-so install-rb

install-so: $(DLLIB) $(TARGET_SO_DIR_TIMESTAMP)
	$(INSTALL_PROG) $(DLLIB) $(RUBYARCHDIR)
clean-static::
	-$(Q)$(RM) $(STATIC_LIB)
install-rb: pre-install-rb do-install-rb install-rb-default
install-rb-default: pre-install-rb-default do-install-rb-default
pre-install-rb: Makefile
pre-install-rb-default: Makefile
do-install-rb:
do-install-rb-default:
pre-install-rb-default:
	@$(NULLCMD)
$(TARGET_SO_DIR_TIMESTAMP):
	$(Q) $(MAKEDIRS) $(@D) $(RUBYARCHDIR)
	$(Q) $(TOUCH) $@

site-install: site-install-so site-install-rb
site-install-so: install-so
site-install-rb: install-rb

.SUFFIXES: .c .m .cc .mm .cxx .cpp .o .S

.cc.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cc.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.mm.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.mm.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.cxx.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cxx.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.cpp.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cpp.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.c.o:
	$(ECHO) compiling $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.c.S:
	$(ECHO) translating $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.m.o:
	$(ECHO) compiling $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.m.S:
	$(ECHO) translating $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

$(TARGET_SO): $(OBJS) Makefile
	$(ECHO) linking shared-object grpc/$(DLLIB)
	-$(Q)$(RM) $(@)
	$(Q) $(LDSHAREDXX) -o $@ $(OBJS) $(LIBPATH) $(DLDFLAGS) $(LOCAL_LIBS) $(LIBS)



$(OBJS): $(HDRS) $(ruby_headers)

remove_unused_artifacts: $(DLLIB)
	$(ECHO) Removing unused object artifacts: rm -rf /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/objs
	$(Q) rm -rf /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/objs
	$(ECHO) Removing unused grpc core libraries: rm -f /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/*.a
	$(Q) rm -f /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/*.a

strip: $(DLLIB)
	$(ECHO) Stripping $(DLLIB)
	$(Q) strip -S -x $(DLLIB)

=== changelog ===
opennebula (7.1.80-1) unstable; urgency=low

  * Build for 7.1.80-1 (Git revision 838542b3)

 -- OpenNebula Team <contact@opennebula.io>  Wed, 25 Feb 2026 11:09:46 +0000

=== control ===
# https://stackoverflow.com/questions/32590638/check-multiple-conditions-at-once-using-m4-preprocessor





Source: opennebula
Section: utils
Priority: extra
Maintainer: OpenNebula Team <contact@opennebula.io>
Build-Depends: bash-completion,
               bison,
               debhelper (>= 7.0.50~),
               default-jdk,
               flex,
               javahelper (>= 0.32),
               libmysql++-dev,
               libsqlite3-dev,
               libssl-dev,
               openssl,
               libxml2-dev,
               libxmlrpc-c++8-dev,
               libxslt1-dev,
               libcurl4-openssl-dev,
               libcurl4,
               libsystemd-dev,
               libvncserver-dev,
               libnsl-dev,
               python3-setuptools,
               ruby,
               scons,
# Rubygems, TODO: reduce
               ruby-dev,
               make,
               gcc,
               libsqlite3-dev,
               libcurl4-openssl-dev,
               rake,
               libxml2-dev,
               libxslt1-dev,
               patch,
               g++,
               build-essential,
               libssl-dev,
               libaugeas-dev,
               nodejs (>= 20), nodejs (< 21),
               npm,
               libzmq5,
               libzmq3-dev,
               make,
               g++,
               python3,
               unzip,
               libtool,
               autoconf,
               libcairo2-dev,
               libossp-uuid-dev,
               freerdp2-dev,
               libssh2-1-dev,
               libpango1.0-dev,
               libpulse-dev,
               libwebp-dev,
               libvorbis-dev,
               default-libmysqlclient-dev | libmysqlclient-dev,
               libabsl-dev,
               libgrpc++-dev,
               protobuf-compiler-grpc,
               protoc-gen-go,
               pkg-config
Standards-Version: 3.9.3
Homepage: http://opennebula.org/
Vcs-Git: git://git.debian.org/pkg-opennebula/opennebula.git
Vcs-Browser: http://git.debian.org/?p=pkg-opennebula/opennebula.git

Package: opennebula
Architecture: any
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: apg,
         xorriso,
         opennebula-common (= ${source:Version}),
         opennebula-tools (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-migration (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         libxmlrpc-c++8v5,
         wget,
         curl,
         rsync,
         tar,
         sqlite3,
         qemu-utils,
         libcurl4,
         iputils-arping,
         file,
         procps,
         sudo,
         uuid-runtime,
         libaugeas0,
         diffutils,
         git,
         patch,
         jq,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ruby-opennebula (<< 5.5.80),
          opennebula-flow (<< 5.0.2),
          opennebula-gate (<< 5.0.2),
          opennebula-common (<< 5.5.80),
          opennebula-addon-markets (<< 5.10.2),
          opennebula-provision (<< 7.0.0),
          opennebula-provision-data (<< 7.0.0),
          onescape (<< 5.13.80)
Breaks:  ruby-opennebula (<< 5.5.80),
         opennebula-flow (<< 5.0.2),
         opennebula-gate (<< 5.0.2),
         opennebula-common (<< 5.5.80),
         opennebula-addon-markets (<< 5.10.2),
         opennebula-provision (<< 7.0.0),
         opennebula-provision-data (<< 7.0.0),
         onescape (<< 5.13.80)
Suggests: mysql-server
Description: OpenNebula Server and Scheduler (Community Edition)

Package: opennebula-dbgsym
Architecture: any
Depends: opennebula (= ${source:Version}),
         ${misc:Depends}
Description: Debug symbols for package opennebula (Community Edition)


Package: opennebula-fireedge
Architecture: any
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         nodejs (>= 20), nodejs (< 21),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: opennebula-guacd (= ${source:Version})
Conflicts: opennebula (<< ${source:Version})
Description: OpenNebula web interface FireEdge (Community Edition)
 Browser based UI for OpenNebula application management.


Package: opennebula-gate
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ${misc:Depends}
Conflicts: opennebula (<< ${source:Version})
Description: OpenNebula Gate server (Community Edition)
 Server for information exchange between Virtual Machines and OpenNebula.

Package: opennebula-flow
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         curl,
         ${misc:Depends}
Conflicts: opennebula (<< ${source:Version})
Description:  OpenNebula Flow server (Community Edition)
 Server for multi-VM orchestration.

Package: opennebula-common
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: adduser,
         openssh-client,
         jq,
         ${misc:Depends}
Recommends: lvm2, sudo (>= 1.7.2p1)
Replaces: opennebula (<< 5.11.90),
          opennebula-node (<< 5.11.90),
          opennebula-node-firecracker (<< 5.11.90)
Breaks: opennebula (<< 5.11.90),
        opennebula-node (<< 5.11.90),
        opennebula-node-firecracker (<< 5.11.90)
Description: Common OpenNebula package shared by various components (Community Edition)

Package: opennebula-common-onecfg
Architecture: all
Depends: ${misc:Depends}
Description: Helpers for OpenNebula onecfg (Community Edition)
Conflicts: opennebula-common-onescape

Package: opennebula-node-kvm
Architecture: all
Depends: adduser,
         libvirt-daemon-system,
         qemu-kvm | pve-qemu-kvm,
         qemu-utils,
         opennebula-common (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ruby,
         vlan,
         ipset,
         pciutils,
         rsync,
         tar,
         cron,
         augeas-tools,
         libxml2-utils,
         iptables,
         nftables,
         libnbd-bin,
         nfs-common,
         python3-numpy,
         python3-scipy,
         dmidecode,
         swtpm-tools,
         ${misc:Depends}
Breaks: opennebula-node (<< 5.13.80)
Replaces: opennebula-node (<< 5.13.80)
Recommends: openssh-server | ssh-server
Provides: opennebula-node
Conflicts: opennebula-node-lxc,
           opennebula-node-lxd,
           opennebula-node-firecracker
Description: Services for OpenNebula KVM node (Community Edition)

Package: opennebula-node-lxc
Architecture: any
Depends: adduser,
         opennebula-common (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ruby,
         vlan,
         ipset,
         pciutils,
         rsync,
         tar,
         cron,
         augeas-tools,
         libarchive-tools,
         libvncserver1,
         qemu-utils,
         bindfs,
         lxc,
         xfsprogs,
         e2fsprogs,
         passwd,
         libxml2-utils,
         iptables,
         nftables,
         nfs-common,
         python3-numpy,
         ${misc:Depends}
Suggests: rbd-nbd
Conflicts: opennebula-node-lxd,
           opennebula-node-kvm,
           opennebula-node-firecracker
Description: Services for OpenNebula LXC node (Community Edition)

Package: python3-pyone
Section: python
Architecture: all
Depends: python3,
         python3-dict2xml,
         python3-lxml,
         python3-requests,
         python3-six,
         python3-tblib,
         python3-xmltodict,
         ${misc:Depends},
         ${python:Depends}
Description: Python 3 bindings for OpenNebula Cloud API, OCA (Community Edition)

Package: opennebula-libs
Architecture: all
Depends: ruby,
         libzmq5,
# Devel package brings libzmq.so symlink required by ffi-rzmq-core gem
         libzmq3-dev,
         opennebula-rubygems (= ${source:Version}),         ${misc:Depends},
         ${ruby:Depends}
Breaks: opennebula-gate (<< 4.90.5),
        opennebula-tools (<< 5.13.80),
        ruby-opennebula (<< 5.13.80),
        opennebula (<< 5.13.80)
Replaces: opennebula-gate (<< 4.90.5),
          opennebula-tools (<< 5.13.80),
          ruby-opennebula (<< 5.13.80),
          opennebula (<< 5.13.80)
Description: OpenNebula libraries (Community Edition)


Package: opennebula-rubygems
Architecture: any
Depends: ruby,
         ${misc:depends},
         ${shlibs:Depends}
Conflicts: opennebula (<< ${source:Version}),
           opennebula-rubygem-activesupport,
           opennebula-rubygem-addressable,
           opennebula-rubygem-amazon-ec2,
           opennebula-rubygem-augeas,
           opennebula-rubygem-aws-eventstream,
           opennebula-rubygem-aws-sdk,
           opennebula-rubygem-aws-sdk-core,
           opennebula-rubygem-aws-sdk-resources,
           opennebula-rubygem-aws-sigv4,
           opennebula-rubygem-azure,
           opennebula-rubygem-azure-core,
           opennebula-rubygem-builder,
           opennebula-rubygem-chunky-png,
           opennebula-rubygem-concurrent-ruby,
           opennebula-rubygem-configparser,
           opennebula-rubygem-curb,
           opennebula-rubygem-daemons,
           opennebula-rubygem-dalli,
           opennebula-rubygem-eventmachine,
           opennebula-rubygem-faraday,
           opennebula-rubygem-faraday-middleware,
           opennebula-rubygem-ffi,
           opennebula-rubygem-ffi-rzmq,
           opennebula-rubygem-ffi-rzmq-core,
           opennebula-rubygem-hashie,
           opennebula-rubygem-highline,
           opennebula-rubygem-i18n,
           opennebula-rubygem-inflection,
           opennebula-rubygem-ipaddress,
           opennebula-rubygem-jmespath,
           opennebula-rubygem-memcache-client,
           opennebula-rubygem-mime-types,
           opennebula-rubygem-mime-types-data,
           opennebula-rubygem-mini-portile2,
           opennebula-rubygem-minitest,
           opennebula-rubygem-multipart-post,
           opennebula-rubygem-mustermann,
           opennebula-rubygem-mysql2,
           opennebula-rubygem-net-ldap,
           opennebula-rubygem-nokogiri,
           opennebula-rubygem-ox,
           opennebula-rubygem-parse-cron,
           opennebula-rubygem-polyglot,
           opennebula-rubygem-public-suffix,
           opennebula-rubygem-rack,
           opennebula-rubygem-rack-protection,
           opennebula-rubygem-rotp,
           opennebula-rubygem-rqrcode,
           opennebula-rubygem-rqrcode-core,
           opennebula-rubygem-scrub-rb,
           opennebula-rubygem-sequel,
           opennebula-rubygem-sinatra,
           opennebula-rubygem-sqlite3,
           opennebula-rubygem-systemu,
           opennebula-rubygem-thin,
           opennebula-rubygem-thor,
           opennebula-rubygem-thread-safe,
           opennebula-rubygem-tilt,
           opennebula-rubygem-treetop,
           opennebula-rubygem-trollop,
           opennebula-rubygem-tzinfo,
           opennebula-rubygem-uuidtools,
           opennebula-rubygem-xmlrpc,
           opennebula-rubygem-xml-simple,
           opennebula-rubygem-zendesk-api
Description: Ruby dependencies for OpenNebula (Community Edition)


Package: opennebula-tools
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         util-linux,
         ${misc:Depends},
         ${ruby:Depends}
Recommends: bash-completion
Suggests: gnuplot-nox
Breaks: opennebula (<< 5.5.90),
        opennebula-addon-tools (<< 5.10.2)
Replaces: opennebula (<< 5.5.90),
          opennebula-addon-tools (<< 5.10.2)

=== rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# Handle group assignment: libvirt (Debian) and libvirtd (Ubuntu)
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	LIB_VIRT_GROUP = libvirt
else
	LIB_VIRT_GROUP = libvirt
endif

# Build arguments
ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	ARGS_ENTERPRISE = yes
else
	ARGS_ENTERPRISE = no
endif

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	ARGS_FIREEDGE = yes
else
	ARGS_FIREEDGE = no
endif

# distribution specific content
DIR_SUDOERS  = 'debian'
DIR_SERVICES = 'systemd'
DIR_TMPFILES = ''
GEMFILE_LOCK = 'Ubuntu2404'

# https://wiki.debian.org/HardeningWalkthrough#Selecting_security_hardening_options
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

dpkg_buildflags = DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed" dpkg-buildflags

# injecting CPPFLAGS to CFLAGS and CXXFLAGS
export CPPFLAGS:=$(shell $(dpkg_buildflags) --get CPPFLAGS)
export CFLAGS:=$(shell $(dpkg_buildflags) --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS:=$(shell $(dpkg_buildflags) --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS:=$(shell $(dpkg_buildflags) --get LDFLAGS)
export MAKEFLAGS:=-j

%:
	dh $@ --with javahelper,bash-completion,systemd

override_dh_auto_build:
	tar xzvf build_opennebula.tar.gz

	# we take only prebuilt Java OCA + deps
	tar xzvf java-oca-*.tar.gz
	mv java-oca-*/jar/ src/oca/java/

	tar xzvf vendor.tar.gz
	for Z in *.zip; do unzip $Z; done
	mv xmlrpc-client-*.jar xmlrpc-common-*.jar ws-commons-util-*.jar src/oca/java/jar/

	tar xzvf one-deploy.tar.gz

ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	tar xzvf opennebula-ee-tools-*.tar.gz
endif
ifneq (,$(filter opennebula-rubygems, $(shell dh_listpackages)))
	tar xzvf opennebula-rubygems-*.tar.gz

	cd opennebula-rubygems-* && \
		NOKOGIRI_USE_SYSTEM_LIBRARIES=yes \
		CPATH=/usr/include/libxml2 \
		GEM_PATH=$$PWD/gems-dist/ \
		GEM_HOME=$$PWD/gems-dist/ \
			gem install \
				--local \
				--ignore-dependencies \
				--no-document \
				--conservative \
				--install-dir $$PWD/gems-dist \
				--bindir $$PWD/gems-dist/bin/ \
				$$(cat manifest)

	# drop build artifacts
	rm -rf opennebula-rubygems-*/gems-dist/cache \
		opennebula-rubygems-*/gems-dist/gems/*/ext
endif
ifneq (,$(filter opennebula-guacd, $(shell dh_listpackages)))
	rm guacamole-server-1.4.0.zip
	unzip guacamole-server-*.zip

	cd guacamole-server-* && \
		autoreconf -i && \
		CFLAGS=-Wno-error ./configure \
			--prefix=/usr/share/one/guacd \
			--exec-prefix=/usr/share/one/guacd \
			--with-freerdp-plugin-dir=/usr/share/one/guacd \
			--disable-static \
			--without-pulse && \
		make
endif

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	# build doesn't have set HOME, also we can't write into /etc
	echo 'cache=/tmp'        >> src/fireedge/.npmrc
	echo 'offline=true'      >> src/fireedge/.npmrc
	echo 'zmq_external=true' >> src/fireedge/.npmrc

	mkdir opennebula-fireedge-modules
	tar -xzvf opennebula-fireedge-modules*.tar.gz \
		-C opennebula-fireedge-modules/ \
		--strip-components=1

	# backup original package-lock.json and update dependencies locations
	# from remote https:// to local predownloaded files
	cd src/fireedge && \
		cp package-lock.json package-lock.json.bak && \
		sed -i -e 's/\(resolved": "\)https*:\/\//\1file:..\/..\/opennebula-fireedge-modules\//' package-lock.json
endif

	#XMLRPC_DIR="debian/" debian/build_opennebula.sh
	./build_opennebula.sh \
			systemd=yes \
			gitversion="$(shell cat debian/gitversion)" \
			enterprise="${ARGS_ENTERPRISE}" \
			fireedge="${ARGS_FIREEDGE}"

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	mv -f src/fireedge/package-lock.json.bak src/fireedge/package-lock.json
	unlink src/fireedge/.npmrc
endif

override_dh_auto_install:
ifeq ($(DEB_TARGET_ARCH),amd64)
	DESTDIR=dist ./install.sh
else
ifeq ($(DEB_TARGET_ARCH),arm64)
	DESTDIR=dist ./install.sh -a arm64
else
	echo "ERROR: Unsupported architecture '$(DEB_TARGET_ARCH)'" >&2
	exit 1
endif
endif

# install one-deploy
	mkdir -p dist/usr/share/one/one-deploy
	cp -a one-deploy/* dist/usr/share/one/one-deploy/

ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	(cd one-ee-tools && \
	DESTDIR=../dist ./install-ee-tools.sh -a /etc/apache2/sites-available -s /etc/systemd/system/apache2.service.d)
	dh_install -p opennebula one-ee-tools/src/onegather/* /usr/bin
	dh_install -p opennebula one-ee-tools/src/onefabric/front-end/onefabric /usr/bin
	dh_install -p opennebula one-ee-tools/src/onefabric/front-end/onefabric_helper.rb /usr/lib/one/ruby/cli/one_helper
endif
ifneq (,$(filter opennebula-guacd, $(shell dh_listpackages)))
	cd guacamole-server-* && \
		make install DESTDIR=$(shell readlink -f dist)

	rm -rf dist/usr/share/one/guacd/include

	dh_install -p opennebula-guacd share/pkgs/services/${DIR_SERVICES}/opennebula-guacd.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-rubygems, $(shell dh_listpackages)))
	cp -a opennebula-rubygems-*/gems-dist dist/usr/share/one/
endif
ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	echo EE > dist/var/lib/one/remotes/EDITION
else
	echo CE > dist/var/lib/one/remotes/EDITION
endif
	dh_auto_install
ifneq (,$(filter opennebula-common, $(shell dh_listpackages)))
	dh_install -p opennebula-common share/pkgs/sudoers/${DIR_SUDOERS}/opennebula \
		/etc/sudoers.d
	dh_install -p opennebula-common share/pkgs/tmpfiles/${DIR_TMPFILES}/opennebula-common.conf \
		/usr/lib/tmpfiles.d/
	dh_install -p opennebula-common share/pkgs/tmpfiles/${DIR_TMPFILES}/opennebula-node.conf \
		/usr/lib/tmpfiles.d/
endif
ifneq (,$(filter opennebula, $(shell dh_listpackages)))
	dh_install -p opennebula share/pkgs/logrotate/opennebula /etc/logrotate.d/
	dh_install -p opennebula share/pkgs/logrotate/opennebula-hem /etc/logrotate.d/

	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-agent.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-socks-cleaner.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-socks-cleaner.timer \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-showback.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-showback.timer \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-hem.service \
		/lib/systemd/system/
	dh_install -p opennebula share/augeas/oned.aug /usr/share/augeas/lenses/
	dh_install -p opennebula share/pkgs/sudoers/opennebula-server /etc/sudoers.d/
endif
ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	dh_install -p opennebula-fireedge share/pkgs/logrotate/opennebula-fireedge /etc/logrotate.d/

	dh_install -p opennebula-fireedge share/pkgs/services/${DIR_SERVICES}/opennebula-fireedge.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-gate, $(shell dh_listpackages)))
	dh_install -p opennebula-gate share/pkgs/logrotate/opennebula-gate /etc/logrotate.d/

	dh_install -p opennebula-gate share/pkgs/services/${DIR_SERVICES}/opennebula-gate.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-flow, $(shell dh_listpackages)))
	dh_install -p opennebula-flow share/pkgs/logrotate/opennebula-flow /etc/logrotate.d/

	dh_install -p opennebula-flow share/pkgs/services/${DIR_SERVICES}/opennebula-flow.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-form, $(shell dh_listpackages)))
	dh_install -p opennebula-form share/pkgs/services/${DIR_SERVICES}/opennebula-form.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-prometheus, $(shell dh_listpackages)))
	dh_install -p opennebula-prometheus src/oneprometheus/alertmanager/systemd/opennebula-alertmanager.service \
		/lib/systemd/system/
